﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ValidationTest
{
    public class Data : INotifyPropertyChanged, IDataErrorInfo
    {
        private double _value;

        public double Value
        {
            get { return _value; }
            set 
            {
                if (value != _value)
                {
                    _value = value;
                    OnPropertyChanged("Value");
                }
            }
        }

        #region INotifyPropertyChanged

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;

            if (handler != null)
                handler(this, new PropertyChangedEventArgs(propertyName));
        }

        #endregion

        #region IDataErrorInfo

        public string Error
        {
            get { return this["Value"]; }
        }

        public string this[string columnName]
        {
            get { return Value < 0 ? "Value cannot be negative" : string.Empty; }
        }

        #endregion
    }
}
